def colormax(r, g, b)

  max = (r.abs)
  if ((g.abs) > max)
          max = (g.abs)
  end
  if ((b.abs) > max)
          max = (b.abs)
  end
  sat = 1.0/max
  
  colr = [(r*sat).abs, (g*sat).abs, (b*sat).abs]

  return colr

end

     toolbar=UI::Toolbar.new "Normal map"

     normal=UI::Command.new("facenormal") {

		model=Sketchup.active_model
		selection=model.selection
		if selection.empty?
			UI.messagebox("No selection. Please select face(s).")
		else
		model.start_operation("Normal map maker (faces)")
		selection.to_a.each do |e|
			if(e.is_a? Sketchup::Face)
				e.material = colormax(e.normal[0], e.normal[1], e.normal[2])
				e.back_material = colormax(e.normal[0], e.normal[1], e.normal[2])
			end
		end
                selection.clear
		model.commit_operation
                end

}
     normal.small_icon="2.png"
     normal.large_icon="2.png"
     normal.tooltip="Color the selected faces by their normal"
     normal.status_bar_text="Color the selected faces by their normal"
     normal.menu_text="Color the selected faces by their normal"

     toolbar=toolbar.add_item normal

     vector=UI::Command.new("edgevector") {
		model=Sketchup.active_model
		selection=model.selection
		if selection.empty?
			UI.messagebox("No selection. Please select face(s).")
		else
		model.start_operation("Normal map maker (edges)")
                  model.rendering_options["EdgeColorMode"]=0
		selection.to_a.each do |edge|
			if(edge.is_a? Sketchup::Edge)

        		vertex0 = edge.start
        		position0 = vertex0.position
        		vertex1 = edge.end
        		position1 = vertex1.position
        		vecteur = position0.vector_to position1
        		vecteur = vecteur.normalize!

			edge.material = colormax(vecteur[0], vecteur[1], vecteur[2])
			end
		end
                  selection.clear
		model.commit_operation
                  end
}
     vector.small_icon="1.png"
     vector.large_icon="1.png"
     vector.tooltip="Color the selected edges by their vector"
     vector.status_bar_text="Color the selected edges by their vector"
     vector.menu_text="Color the selected edges by their vector"

     toolbar=toolbar.add_item vector

     toolbar.show
